﻿using System;
using System.Windows.Forms;
using System.IO.Ports;

namespace SerialSample10
{
    public partial class Form1 : Form
    {
        SerialPort ComPort = new SerialPort("COM1");
        int command, address, control;
        public Form1()
        {
            InitializeComponent();
            ComPort.BaudRate = 9600;
            ComPort.Parity = Parity.None;
            ComPort.StopBits = StopBits.One;
            ComPort.DataBits = 8;
            ComPort.Handshake = Handshake.None;
            ComPort.DataReceived += OnSerialDataReceived;
            ComPort.Open();
        }

        private void OnSerialDataReceived(object sender, SerialDataReceivedEventArgs args)
        {
            command = ComPort.ReadByte();
            address = ComPort.ReadByte();
            control = ComPort.ReadByte();
            lblCommand.Invoke(new EventHandler(lblCommand_DataReceived));
            lblAddress.Invoke(new EventHandler(lblAddress_DataReceived));
            lblControl.Invoke(new EventHandler(lblControl_DataReceived));
            if (command == 12) MessageBox.Show("Power pressed!");
        }

        private void lblCommand_DataReceived(object sender, EventArgs e)
        {
            lblCommand.Text = command.ToString();
        }

        private void lblAddress_DataReceived(object sender, EventArgs e)
        {
            lblAddress.Text = address.ToString();
        }

        private void lblControl_DataReceived(object sender, EventArgs e)
        {
            if (control != 0) lblControl.Text = "New press"; else lblControl.Text = "Continuous press";
        }
    }
}
