﻿using System;
using System.IO.Ports;
using System.Windows.Forms;

namespace SerialSample6
{
    public partial class Form1 : Form
    {
        SerialPort ComPort = new SerialPort("COM1");
        int val = 0;
        public Form1()
        {
            InitializeComponent();
            if (ComPort.IsOpen) ComPort.Close();
            ComPort.BaudRate = 9600;
            ComPort.Parity = Parity.None;
            ComPort.StopBits = StopBits.One;
            ComPort.DataBits = 8;
            ComPort.Handshake = Handshake.None;
            ComPort.DataReceived += OnSerialDataReceived;
            ComPort.Open();
        }

        private void OnSerialDataReceived(object sender, SerialDataReceivedEventArgs args)
        {
            while (ComPort.ReadByte() != 0xff);
            char[] c = new char[4];
            ComPort.Read(c, 0, 4);
            string strVal = new string(c);
            try
            {
                val = Convert.ToInt32(strVal, 16);
            } catch (System.FormatException) {
            }
            ComPort.ReadExisting();
            lblValue.Invoke(new EventHandler(lblValue_DataReceived));
        }

        private void lblValue_DataReceived(object sender, EventArgs e)
        {
            lblValue.Text = val.ToString();
            progressBar1.Value = val;
            if (val > 0) progressBar1.Value = val - 1;
            progressBar1.Value = val;
            double valf = (double)val / 399.6;
            lblVoltage.Text = valf.ToString("0.0000") + " V";
            ComPort.Write("x");
        }
    }
}
