﻿using System;
using System.IO.Ports;
using System.Windows.Forms;

namespace SerialSample8
{
    public partial class Form1 : Form
    {
        SerialPort ComPort = new SerialPort("COM1");

        public Form1()
        {
            InitializeComponent();
            if (ComPort.IsOpen) ComPort.Close();
            ComPort.BaudRate = 9600;
            ComPort.Parity = Parity.None;
            ComPort.StopBits = StopBits.One;
            ComPort.DataBits = 8;
            ComPort.Handshake = Handshake.None;
            ComPort.Open();
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x01 }, 0, 1);
        }

        private void btnSendText_Click(object sender, EventArgs e)
        {
            ComPort.Write(txtLine1.Text);
            ComPort.Write(new byte[] { 0x00 }, 0, 1);
            ComPort.Write(txtLine2.Text);
            ComPort.Write(new byte[] { 0xff }, 0, 1);
        }

        private void btnCursorOn_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x02 }, 0, 1);
        }

        private void btnCursorOff_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x03 }, 0, 1);
        }

        private void btnBlinkOn_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x04 }, 0, 1);
        }

        private void btnBlinkOff_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x05 }, 0, 1);
        }

        private void btnCursorLeft_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x06 }, 0, 1);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x07 }, 0, 1);
        }

        private void btnScrollLeft_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x08 }, 0, 1);
        }

        private void btnScrollRight_Click(object sender, EventArgs e)
        {
            ComPort.Write(new byte[] { 0x09 }, 0, 1);
        }

        private void btnAppend_Click(object sender, EventArgs e)
        {
            ComPort.Write(txtLine1.Text);
            ComPort.Write(new byte[] { 0x00 }, 0, 1);
            ComPort.Write(new byte[] { 0xfe }, 0, 1);
        }
    }
}
