﻿using System;
using System.IO.Ports;
using System.Windows.Forms;
using System.Threading;

namespace WinLin
{
    public partial class Form1 : Form
    {

        SerialPort ComPort;
        string state = "";
        Thread listenerThread;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] theSerialPorts = System.IO.Ports.SerialPort.GetPortNames();
            cmbPorts.Items.AddRange(theSerialPorts);
            cmbPorts.Text = cmbPorts.Items[0].ToString();
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            ComPort = new SerialPort(cmbPorts.SelectedItem.ToString());
            ComPort.BaudRate = 9600;
            ComPort.Parity = Parity.None;
            ComPort.StopBits = StopBits.One;
            ComPort.DataBits = 8;
            ComPort.Handshake = Handshake.None;
            ComPort.Open();
            listenerThread = new Thread(listen);
            listenerThread.Start();
            btnOff.Enabled = true;
            btnOn.Enabled = true;
            btnOpen.Enabled = false;
        }

        private void lblState_DataReceived(object sender, EventArgs e)
        {
            lblState.Text = "Button is " + state + ".";
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (ComPort!=null) ComPort.Close();
            if(listenerThread!=null) listenerThread.Abort();
        }

        private void btnOn_Click(object sender, EventArgs e)
        {
            ComPort.Write("a");
        }

        private void btnOff_Click(object sender, EventArgs e)
        {
            ComPort.Write("b");
        }

        void listen()
        {
            while(true) {
                byte[] buffer = new byte[1];
                int read = 0;
                try
                {
                    read = ComPort.Read(buffer, 0, 1);
                }
                catch (System.IO.IOException e)
                {
                    break;
                }
                byte val = buffer[0];
                if (val == 'P') state = "pressed"; else state = "released";
                lblState.Invoke(new EventHandler(lblState_DataReceived));
            }
        }
    }
}
